#include <iostream.h>
#include <fstream.h>

#define TRUE          1
#define FALSE         0

struct record {
  char processor[16];
  int  speed;
  int  memory;
  int  HDD;
  char video[16];
  int price;
  record *next;
} *beg_q = NULL, *end_q = NULL;

const char numbers[10] = {'0','1','2','3','4','5','6','7','8','9'};
int modified = FALSE;

void Sort_1(int);
void Sort_2(int);
void FieldNames();
void OutFields(int, record *);
void StrCat(char *, char *);
int  Compare(record, record);
int  StrToInt(char *);
int  StrLen(char *);
void StrCpy(char *, char *);
char Answer(char *);
int  StrLen(char *);
int  StrCmp(char *, char *);
void GetRec(char *, char *s, int length);
void GetRec(char *, int &);
void FillRecord(record &);
void About();
void Title(char *);
int  Menu();
void Help();
void Load();
void Save();
void View();
void Clear(int);
void Add();
void Del();
void Edit();
void Sort();
void Search();
void main();

void About()
{
  for (int i = 0; i < 25; i++, cout << "\n");
  cout << "\n";
  cout << "******************************************************************************\n";
  cout << "*                         DATABASE \"COMPUTERS\".                              *\n";
  cout << "*                  Written by Voinov Sergey 3IT-41, 1998                     *\n";
  cout << "******************************************************************************\n";
  cout << "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n";
  cout << "                        Press Enter to continue...";
  cin.get();
}

void Title(char *s)
{
  int j = 0;

  cout << "|----------------------------------------------------------------------------|\n";
  cout << "|                             DATABASE \"COMPUTERS\"                           |\n";
  cout << "|----------------------------------------------------------------------------|\n";
  cout << "|";
  for (int i = 0; i < 39 - StrLen(s) / 2 - 7; i++, j++, cout << " ");
  cout << "****** ";
  cout << s;
  cout << " ******";
  for (int n = 0; n < 78 - j - 16 - StrLen(s); n++, cout << " ");
  cout << "|\n";
  cout << "|----------------------------------------------------------------------------|\n";
}

char Answer(char *message)
{
  char buf[129];

  cout << "\n";
  cout << message;
  cin.getline(buf, 128);
  cout << "\n";
  return buf[0];
}

int StrToInt(char *s)
{
  int n = 0, flag, mul = 1;
  char *t = s;

  while (*s++) {}
  s -= 2;

  while (s >= t)
  {
    flag = 0;
    for (int i = 0; i < 10; i++)
      if (*s == numbers[i])
      {
        flag |= 1;
        n += mul * i;
      }
    if (!flag) return -1;
    mul *= 10;
    s--;
  }

  return n;
}

int StrLen(char *s)
{
  int n = 0;
  while (*s++) n++;
  return n;
}

void StrCat(char *s1, char *s2)
{
  while (*s1++);
  s1--;
  while (*s2) *s1++ = *s2++;
  *s1 = *s2;
}

int  StrCmp(char *s1, char *s2)
{
  int n = StrLen(s1), m = StrLen(s2);
  if (n != m)
  {
    if (n > m)
      return 1;
    else
      return -1;
  }
  for (int i = 0; i < n; i++)
    if (*s1++ != *s2++)
    {
      if (*--s1 > *--s2)
        return 1;
      else
        return -1;
    }
  return 0;
}

void StrCpy(char *s1, char *s2)
{
  while (*s2) *s1++ = *s2++;
  *s1 = *s2;
}

int Menu()
{
  char c[129];

  Title("MAIN MENU");
  cout << "                                                                              \n";
  cout << "                    |=======================================|                 \n";
  cout << "                    |          1. Help                      |                 \n";
  cout << "                    |          2. Load DataBase             |                 \n";
  cout << "                    |          3. Save DataBase             |                 \n";
  cout << "                    |          4. View DataBase             |                 \n";
  cout << "                    |          5. Clear DataBase            |                 \n";
  cout << "                    |          6. Add record(s)             |                 \n";
  cout << "                    |          7. Delete record(s)          |                 \n";
  cout << "                    |          8. Edit record               |                 \n";
  cout << "                    |          9. Sort records              |                 \n";
  cout << "                    |         10. Search record(s)          |                 \n";
  cout << "                    |         11. Exit                      |                 \n";
  cout << "                    |=======================================|                 \n";
  cout << "\n\n\n\n\n";
  cout << "                                 Your choice: ";
  cin.getline(c, 128);
  cout << "\n";

  return StrToInt(c);
}

void Help()
{
  Title("HELP");
  cout << "\n";

  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";
  cout << "..............................................................................\n";

  cout << "\nPress Enter to continue.\n";
  cin.get();
}

void Load()
{
  char name[129];
  char buf[81];
  record r, *p;
  int n = 0;

  Title("LOAD DATABASE");
  cout << "\nEnter file name to access database: ";
  cin.getline(name, 128);
  ifstream in(name);

  if (!in)
  {
    cout << "Unable to load DataBase";
    Answer("Press Enter to continue...");
    return;
  }

  Clear(0);
  for (int i = 0; i < 6; i++)
    in.getline(buf, 80);

  do
  {
    in >> buf;
    in.getline(r.processor, 20, '\"');
    in.getline(r.processor, 20, '\"');
    in >> buf;
    r.speed = StrToInt(buf);
    in >> buf;
    r.memory = StrToInt(buf);
    in >> buf;
    r.HDD = StrToInt(buf);
    in.getline(r.video, 20, '\"');
    in.getline(r.video, 20, '\"');
    in >> buf;
    r.price = StrToInt(buf);
    if ((r.speed < 0) || (r.memory < 0) || (r.HDD < 0) || (r.price < 0))
    {
      cout << "DataBase file is corrupt.";
      Answer("Press Enter to continue...");
      return;
    }
    if (StrCmp(r.processor, ""))
    {
      p = new record;
      if (p == NULL)
      {
        cout << "Not enough memory to add record.\n";
        Answer("Press Enter to continue...");
        return;
      }
      p -> next = NULL;
      StrCpy(p -> processor, r.processor);
      p -> speed = r.speed;
      p -> memory = r.memory;
      p -> HDD = r.HDD;
      StrCpy(p -> video, r.video);
      p -> price = r.price;
      if (beg_q == NULL)
        beg_q = p;
      else
        end_q -> next = p;
      end_q = p;
      n++;
    }
  } while (in && StrCmp(r.processor, ""));

  in.close();
  cout << n << " records read.\n";
  if(!n) cout << "May be binary file.";
  Answer("Press Enter to continue...");
  modified = FALSE;
}

void Save()
{
  char name[129], buf[20];
  record *r = beg_q;
  int n = 0;

  Title("SAVE DATABASE");

  if (beg_q == NULL)
  {
    cout << "DataBase is empty.\n";
    Answer("Press Enter to continue...");
    return;
  }

  cout << "\nEnter database name: ";
  cin.getline(name, 128);
  ofstream out(name);

  if (!out)
  {
    cout << "Unable to save DataBase.\n";
    Answer("Press Enter to continue...");
    return;
  }

  out << "|----------------------------------------------------------------------------|\n";
  out << "|                             DATABASE \"COMPUTERS\"                           |\n";
  out << "|----------------------------------------------------------------------------|\n\n";

  out.width(5);
  out << "N";
  out.width(20);
  out << "Processor type";
  out.width(7);
  out << "Speed";
  out.width(7);
  out << "Mem";
  out.width(7);
  out << "HDD";
  out.width(20);
  out << "Video adapter";
  out.width(7);
  out << "Price";
  out.width(0);
  out << "\n-----------------------------------------------------------------------------";

  while (r)
  {
    n++;

    out << "\n";
    out.width(5);
    out << n;
    out.width(20);
    StrCpy(buf, "\"");
    StrCat(buf, r -> processor);
    StrCat(buf, "\"");
    out << buf;
    out.width(7);
    out << r -> speed;
    out.width(7);
    out << r -> memory;
    out.width(7);
    out << r -> HDD;
    out.width(20);
    StrCpy(buf, "\"");
    StrCat(buf, r -> video);
    StrCat(buf, "\"");
    out << buf;
    out.width(7);
    out << r -> price;

    r = r -> next;
  }

  modified = FALSE;
  out.close();
}

void FieldNames()
{
  cout << "\n";
  cout.width(5);
  cout << "N";
  cout.width(20);
  cout << "Processor type";
  cout.width(7);
  cout << "Speed";
  cout.width(7);
  cout << "Mem";
  cout.width(7);
  cout << "HDD";
  cout.width(20);
  cout << "Video adapter";
  cout.width(7);
  cout << "Price";
  cout.width(0);
  cout << "\n-----------------------------------------------------------------------------";
}

void OutFields(int m, record *r2)
{
  cout << "\n";
  cout.width(5);
  cout << m + 1;
  cout.width(20);
  cout << r2 -> processor;
  cout.width(7);
  cout << r2 -> speed;
  cout.width(7);
  cout << r2 -> memory;
  cout.width(7);
  cout << r2 -> HDD;
  cout.width(20);
  cout << r2 -> video;
  cout.width(7);
  cout << r2 -> price;
}

void View()
{
  record *r2 = beg_q;
  int n = 0, m = 0;
  char c;

  Title("VIEW DATABASE");

  if (beg_q == NULL)
  {
    cout << "DataBase is empty.\n";
    Answer("Press Enter to continue...");
    return;
  }

  cout << "\n";

  while (r2)
  {
    if (!n) FieldNames();
    OutFields(m, r2);
    n++;
    m++;
    if (n > 21)
    {
      n = 0;
      Answer("Press Enter to continue...");
    }
    r2 = r2 -> next;
  }

  cout << "\n-----------------------------------------------------------------------------\n";
  Answer("\nPress Enter to continue...");
}

void Clear(int ask)
{
  record *r2 = beg_q, *p = r2;

  if (ask) Title("CLEAR DATABASE");

  if (beg_q == NULL)
  {
    if (ask)
    {
      cout << "DataBase is empty.\n";
      Answer("Press Enter to continue...");
    }
    return;
  }

  if (ask)
  {
    cout << "\nWARNING! All records will be deleted!\n";
    char c = Answer("Do you want to clear database (Y/N)? ");
    if (c != 'y' && c != 'Y') return;
  }

  while (r2)
  {
    p -> next = r2 -> next;
    if (beg_q == end_q)
    {
      beg_q = NULL;
      end_q = NULL;
    }
    else
    {
      if (r2 == beg_q) beg_q = p -> next;
      if (r2 == end_q) end_q = p;
    }
    delete r2;
    r2 = p -> next;
  }

  if (ask)
  {
    cout << "\nDataBase cleared.\n";
    Answer("Press Enter to continue...");
  }
}

void Edit()
{
  Title("EDIT RECORD");

  if (beg_q == NULL)
  {
    cout << "DataBase is empty.\n";
    Answer("Press Enter to continue...");
    return;
  }

  cout << "\nSelect record you want to edit:\n";
}

void GetRec(char *message, char *s, int length)
{
  int flag = 0;
  char buf[129];

  do
  {
    cout << message;
    cin.getline(buf, 128);
    flag = 0;
    if (StrLen(buf) > length)
    {
      cout << "Length of string out of bounds!\n";
      flag = 1;
    }
  } while (flag);

  int i = 0;
  while (buf[i])
  {
    *s = buf[i];
    s++;
    i++;
  }
  *s = '\0';
}

void GetRec(char *message, int &n)
{
  int flag = 0;
  char buf[129];

  do
  {
    cout << message;
    cin.getline(buf, 128);
    flag = 0;
    if (StrLen(buf) > 9)
    {
      cout << "Length of string out of bounds!\n";
      flag = 1;
    }
    if ((StrToInt(buf) < 0) && (*buf != '*'))
    {
      cout << "Number entered incorrectly!\n";
      flag = 1;
    }
  } while (flag);

  if (*buf == '*')
    n = -1;
  else
    n = StrToInt(buf);
}

void FillRecord(record &r)
{
  GetRec("Enter processor type: ", r.processor, 15);
  GetRec("Enter processor speed (MHz): ", r.speed);
  GetRec("Enter memory size (Mb): ", r.memory);
  GetRec("Enter HDD size (Mb): ", r.HDD);
  GetRec("Enter video adapter name: ", r.video, 15);
  GetRec("Enter price of computer ($): ", r.price);
}

void Add()
{
  record r, *p;
  char c;

  Title("ADD RECORD");
  cout << "\n";

  do
  {
    FillRecord(r);
    p = new record;
    if (p == NULL)
    {
      cout << "Not enough memory to add record.\n";
      Answer("Press Enter to continue...");
      return;
    }
    p -> next = NULL;
    StrCpy(p -> processor, r.processor);
    p -> speed = r.speed;
    p -> memory = r.memory;
    p -> HDD = r.HDD;
    StrCpy(p -> video, r.video);
    p -> price = r.price;
    if (beg_q == NULL)
      beg_q = p;
    else
      end_q -> next = p;
    end_q = p;
    modified = TRUE;
    c = Answer("Do you want to add next record (Y/N)? ");
  } while (c == 'y' || c == 'Y');
}

int Compare(record r1, record *r2)
{
  if ((StrCmp(r1.processor, r2 -> processor) && (r1.processor[0] != '*')) ||
     ((r1.speed != r2 -> speed) && (r1.speed != -1)) ||
     ((r1.memory != r2 -> memory) && (r1.memory != -1)) ||
     ((r1.HDD != r2 -> HDD) && (r1.HDD != -1)) ||
     ((StrCmp(r1.video, r2 -> video)) && (r1.video[0] != '*')) ||
     ((r1.price != r2 -> price) && (r1.price != -1))) return 1;

  return 0;
}

void Del()
{
  char c;
  int n = 0;
  record r1, *r2 = beg_q, *p = r2;

  Title("DELETE RECORD");

  if (beg_q == NULL)
  {
    cout << "DataBase is empty.\n";
    Answer("Press Enter to continue...");
    return;
  }

  FillRecord(r1);

  while (r2)
  {
    if (!Compare(r1, r2)) n++;
    r2 = r2 -> next;
  }

  if (!n)
  {
    cout << "No records found.\n";
    Answer("Press Enter to continue...");
  }
  else
  {
    cout << "Are you sure you want do delete " << n << " record(s) ";
    c = Answer("(Y/N)? ");
    if ((c == 'y') || (c == 'Y'))
    {
      r2 = beg_q;
      while (r2)
      {
        if (!Compare(r1, r2))
        {
          p -> next = r2 -> next;
          if (beg_q == end_q)
          {
            beg_q = NULL;
            end_q = NULL;
          }
          else
          {
            if (r2 == beg_q) beg_q = p -> next;
            if (r2 == end_q) end_q = p;
          }
          delete r2;
          r2 = p -> next;
        }
        else
        {
          p = r2;
          r2 = r2 -> next;
        }
      }
      modified = TRUE;
    }
  }
}

void Sort_1(int by)
{
  record *r1 = beg_q, *r2, t, *p;
  char a[21], b[21];

  while (r1 -> next)
  {
    r2 = r1 -> next;
    while (r2)
    {
      switch (by)
      {
        case 0: StrCpy(a, r1 -> processor); StrCpy(b, r2 -> processor); break;
        case 1: StrCpy(a, r1 -> video); StrCpy(b, r2 -> video); break;
      }
      if (StrCmp(b, a) == -1)
      {
        t = *r1;
        *r1 = *r2;
        *r2 = t;
        p = r1 -> next;
        r1 -> next = r2 -> next;
        r2 -> next = p;
        modified = TRUE;
      }
      r2 = r2 -> next;
    }
    r1 = r1 -> next;
  }
}

void Sort_2(int by)
{
  record *r1 = beg_q, *r2, t, *p;
  int a, b;

  while (r1 -> next)
  {
    r2 = r1 -> next;
    while (r2)
    {
      switch (by)
      {
        case 0: a = r1 -> speed; b = r2 -> speed; break;
        case 1: a = r1 -> memory; b = r2 -> memory; break;
        case 2: a = r1 -> HDD; b = r2 -> HDD; break;
        case 3: a = r1 -> price; b = r2 -> price; break;
      }
      if (b < a)
      {
        t = *r1;
        *r1 = *r2;
        *r2 = t;
        p = r1 -> next;
        r1 -> next = r2 -> next;
        r2 -> next = p;
        modified = TRUE;
      }
      r2 = r2 -> next;
    }
    r1 = r1 -> next;
  }
}

void Sort()
{
  char c[129], ch;
  int number;

  if (beg_q == NULL)
  {
    Title("SORT RECORDS");
    cout << "DataBase is empty.\n";
    Answer("Press Enter to continue...");
    return;
  }

  do
  {
    Title("SORT RECORDS");

    cout << "\n\n\n\n";
    cout << "                    |=======================================|                 \n";
    cout << "                    | Sort by...  1. Processor type         |                 \n";
    cout << "                    |             2. Processor speed        |                 \n";
    cout << "                    |             3. Memory size            |                 \n";
    cout << "                    |             4. HDD size               |                 \n";
    cout << "                    |             5. Video adapter type     |                 \n";
    cout << "                    |             6. Price of computer      |                 \n";
    cout << "                    |                                       |                 \n";
    cout << "                    |             7. Return to main menu    |                 \n";
    cout << "                    |=======================================|                 \n";
    cout << "\n\n\n\n\n";
    cout << "Sort records by what field: ";
    cin.getline(c, 128);
    cout << "\n";
    number = StrToInt(c);
  } while (number < 1 || number > 7);

  if (number == 7) return;

  switch (number)
  {
    case 1: Sort_1(0); break;
    case 2: Sort_2(0); break;
    case 3: Sort_2(1); break;
    case 4: Sort_2(2); break;
    case 5: Sort_1(1); break;
    case 6: Sort_2(3);
  }

  cout << "Sorting complete.";
  ch = Answer("Do you want to view sorted DataBase (Y/N)? ");
  if ((ch == 'y') || (ch == 'Y')) View();
}

void Search()
{
  record r1, *r2 = beg_q;
  int n = 0, m = 0;
  char c;

  Title("SEARCH RECORDS");

  if (beg_q == NULL)
  {
    cout << "DataBase is empty.\n";
    Answer("Press Enter to continue...");
    return;
  }

  cout << "\nYou can use mask \"*\"\n\n";

  FillRecord(r1);
  cout << "\n";

  while (r2)
  {
    if (!Compare(r1, r2))
    {
      if (!n) FieldNames();
      OutFields(m, r2);
      n++;
      m++;
      if (n > 21)
      {
        n = 0;
        Answer("Press Enter to continue...");
      }
    }
    r2 = r2 -> next;
  }

  cout << "\n-----------------------------------------------------------------------------\n";
  cout << "\n" << m << " record(s) found.\n";
  Answer("Press Enter to continue...");
}

void main()
{
  char c = '\0';
  int choice;

  About();

  do
  {
    choice = Menu();

    switch (choice)
    {
      case 1:  Help(); break;
      case 2:  Load(); break;
      case 3:  Save(); break;
      case 4:  View(); break;
      case 5:  Clear(1); break;
      case 6:  Add(); break;
      case 7:  Del(); break;
      case 8:  Edit(); break;
      case 9:  Sort(); break;
      case 10: Search(); break;
      case 11: c = Answer("Are you sure (Y/N)? ");
    };
  } while (c != 'y' && c != 'Y');
  if (modified)
  {
    c = Answer("DataBase modified. Save changes (Y/N)? ");
    if ((c == 'y') || (c == 'Y'))
    {
      Save();
    }
  }
}
